import java.awt.Color;

public class PredatorFish extends Fish
{
	private int stepsStarved;
	
	public PredatorFish(Environment env, Location loc)
	{
		super(env,loc);
		stepsStarved = 0;
	}


	public PredatorFish(Environment env, Location loc, Direction dir)
	{
		super(env,loc, dir);
		stepsStarved = 0;
	}



	public PredatorFish(Environment env, Location loc, Direction dir, Color col)
	{
		super(env,loc, dir,col);
		stepsStarved = 0;
	}
	
	protected void generateChild(Location loc)
	{
		new PredatorFish(environment(),loc, environment().randomDirection(), color());
	}
	
	protected boolean eat()
	{
		Environment env = environment();
		Location front = env.getNeighbor(location(),direction());
		Locatable obj = env.objectAt(front);
		
		if(obj != null)
		{
			env.remove(obj);
			return true;
		}
		
		return false;
	}
	
	public void act()
	{
		if(!isInEnv())
			return;
		
		if(eat())
		   stepsStarved = 0;
		else
		   stepsStarved++;
		
		
		if(stepsStarved >= 5)
		    die();
		super.act();
	}

}