//
//  MyRobot.java
//  Sprinter
//
//  Created by Don Slater on Sun Dec 15 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

package kareltherobot;

public class MyRobot extends Robot {

    public MyRobot(int str, int ave, Directions.Direction dir, int count) {
    
        super(str, ave, dir, count);
    }
    
    /**
    *	robot rotates 90 degrees clockwise from current diection
    *	position is unchanged, number of beepers carried is unchanged
    *	number of beepers the robot may be next to is unchanges
    */
    public void turnRight() {
    
        turnLeft();
        turnLeft();
        turnLeft();
    }
    
    /**
    *	robot rotates 180 degrees from current direction
    *	position is unchanged, number of beepers carried is unchanged
    *	number of beepers the robot may be next to is unchanged
    */
    public void turnAround() {
        
        turnLeft();
        turnLeft();
    }
    
    /**
    *	robot rotates has moved backward one step from its previous position
    *	direction is unchanged, number of beepers carried is unchanged
    *	number of beepers the robot may be next to is unchanges
    */
    public void stepBack() {
    
        turnAround();
        move();
        turnAround();
    }
    
    /**
    *	robot determines if there is a wall immediately to its left
    *	position is unchanged, number of beepers carried is unchanged
    *	direction is unchanged, number of beepers the robot may be next to is unchanged
    *
    *	@return true if there is a wall on the left, false otherwise
    */
    public boolean leftIsBlocked() {
    
        turnLeft();
        if (! frontIsClear()) {
            turnRight();
            return true;
        } else {
            turnRight();
            return false;
        }
    }
    

    /**
    *	robot moves forward as long as there is a wall on the left
    *	number of beepers carried is unchanged
    *	direction is unchanged
    */
    public void followWallLeft() {
    
        while (leftIsBlocked()) {
            move();
        }
    }

    /**
    *	robot determines if there is a wall immediately to its right
    *	position is unchanged, number of beepers carried is unchanged
    *	direction is unchanged, number of beepers the robot may be next to is unchanged
    *
    *	@return true if there is a wall on the right, false otherwise
    */
    public boolean rightIsBlocked() {
    
        turnRight();
        if (! frontIsClear()) {
            turnLeft();
            return true;
        } else {
            turnLeft();
            return false;
        }
    }
    
    /**
    *	robot moves forward as long as there is a wall on the right
    *	number of beepers carried is unchanged
    *	direction is unchanged
    */
    public void followWallRight() {
    
        while (rightIsBlocked()) {
            move();
        }
    }
    
    /**
    *	robot moves forward as long as there is no wall until there path is blocked
    *	by a wall; number of beepers carried is unchanged
    *	direction is unchanged
    */
    public void findWall() {
    
        while (frontIsClear()) {
            move();
        }
    }
    
    
    /**
    *	robot rotates from current direction until it is facing North
    *	position is unchanged, number of beepers carried is unchanged
    *	number of beepers the robot may be next to is unchanged
    */
    public void faceNorth() {
    
        while (! facingNorth()) {
            turnLeft();
        }
    }

    /**
    *	robot rotates from current direction until it is facing South
    *	position is unchanged, number of beepers carried is unchanged
    *	number of beepers the robot may be next to is unchanged
    */
    public void faceSouth() {
    
        while (! facingSouth()) {
            turnLeft();
        }
    }

    /**
    *	robot rotates from current direction until it is facing East
    *	position is unchanged, number of beepers carried is unchanged
    *	number of beepers the robot may be next to is unchanged
    */
    public void faceEast() {
    
        while (! facingEast()) {
            turnLeft();
        }
    }

    /**
    *	robot rotates from current direction until it is facing West
    *	position is unchanged, number of beepers carried is unchanged
    *	number of beepers the robot may be next to is unchanged
    */
    public void faceWest() {
    
        while (! facingWest()) {
            turnLeft();
        }
    }

}
