/** 
 * Application.java
 
 * Title:		Application
 * Description:		Driver class for Karel J. Robot applications. static initializer sets up
 *			the environment by opening the World file. main() instantiates the robot
 *			and invokes he methods to complete the task.
 * @author		djslater
 * @version		2.0
 */

package kareltherobot; 

import javax.swing.JOptionPane;

public class Application implements Directions {

	
	// Main entry point
	static public void main(String[] args) {
	
		RacerRobot Carl = new Sprinter(1, 1, East, 0);
                Carl.runRace();
                
                Carl = new Hurdler(3, 1, East, 0);
                Carl.runRace();
                
		Carl = new HighHurdler(6, 1, East, 0);
                Carl.runRace();
                
		Carl = new SteepleChaser(10, 1, East, 0);
                Carl.runRace();
	}
	
	static {
	
                World.readWorld("raceCourse.txt");
                World.setSize(20, 30);
		World.setVisible(true);
                World.setTrace(false);
		World.setDelay(10);
	
	}
}
